from . import db 
from flask_login import UserMixin
from sqlalchemy.sql import func
from sqlalchemy.orm import mapped_column
from sqlalchemy import ForeignKey


#Answer that the chatbot can give
class Answer(db.Model):
    __tablename__ = "answer"
    id = db.Column(db.Integer, primary_key=True)
    answer = db.Column(db.String(150))
    lable = db.Column(db.String(150), unique=True)
    description = db.Column(db.String(150))
    state = db.Column(db.Integer)

#Keywords used for seasonal answers
class Keyword(db.Model):
    id = db.Column(db.Integer, primary_key=True)
    word = db.Column(db.String(50))
    answer_id = mapped_column(ForeignKey("answer.id"))

#Question asked to the chatbot.
class Question(db.Model):
    
    id = db.Column(db.Integer, primary_key=True)
    timestamp = db.Column(db.DateTime)
    message = db.Column(db.String(150))
    bot_answer_id = mapped_column(ForeignKey("answer.id"))
    true_answer_id =  mapped_column(ForeignKey("answer.id"))
    confidence = db.Column(db.Float)
    state = db.Column(db.Integer)

#User that have access to the website
class User(db.Model,UserMixin):
    __tablename__ = "user"
    id = db.Column(db.Integer, primary_key=True)
    first_name = db.Column(db.String(150))
    last_name = db.Column(db.String(150))
    email = db.Column(db.String(150), unique=True)
    password = db.Column(db.String(150))


#Tabel with every instance of the bot being trained
class Trained(db.Model):
    id = db.Column(db.Integer, primary_key=True)
    timestamp = db.Column(db.DateTime)
    datapoints = db.Column(db.Integer)
    user_id = mapped_column(ForeignKey("user.id"))
