let timeout;
let userLoggedOut = false;

function isLoginOrSignupPage() {
  const loginUrl = '/login'; 
  const signupUrl = '/sign_up'; 
  return window.location.pathname === loginUrl || window.location.pathname === signupUrl;
}

function startTimer() {
  if (isLoginOrSignupPage()) return;

  clearTimeout(timeout);
  timeout = setTimeout(logout, 30 * 60 * 1000);  // 30 minutes inactivity time (30 minutes * 60 seconds * 1000 milliseconds)
}

function logout() {
  userLoggedOut = true;
  window.location.href = '/logout?auto=1';
}

function resetTimer() {
  if (!userLoggedOut && !isLoginOrSignupPage()) {
    startTimer();
  }
}

window.onload = startTimer;
window.onmousemove = resetTimer;
window.onmousedown = resetTimer;
window.ontouchstart = resetTimer;
window.onclick = resetTimer;
window.onkeypress = resetTimer;
