//QuestionEnum
var NOT_VALIDATED = 1;
var VALIDATED = 2;   
var TRAINED_ON = 3; 

countCheckboxBox();
dontToggle();
/**
 * Add or remove styling for check/uncheck box
 * @param {HTMLElement} checkbox 
 */
function toggleCardColor(checkbox) {
    var card = checkbox.closest(".card");
    if (checkbox.checked) {
        if (checkbox.value == TRAINED_ON) {
            card.classList.add("traind-card");
        } else {
        card.classList.add("checked-or-valid-card");
        }
    } else {
        card.classList.remove("traind-card");
        card.classList.remove("checked-or-valid-card");
    }
}

/**
 * When pushing "valid" button the question gets checked, the color turns green, and the number of checked chekboxes gets updated.
 * @param {Integer} index
 */
function checkCheckbox(index){
    var checkbox = document.querySelector('#checkboxQuestion'+index);
    checkbox.checked = true;
    toggleCardColor(checkbox);
    countCheckboxBox();
}
/**
 * Changes a questions head answer and true answer to be equal to the dropdown where you chose true answer
 * @param {String} index 
 */
function updateTrueAnswer(index){
    var head_answer = document.querySelector('#head_answer_'+index);
    var body_true_answer = document.querySelector('#body_answer_'+index);
    var select_true_answer = document.querySelector('#select'+index);

    head_answer.textContent = select_true_answer.options[select_true_answer.selectedIndex].textContent;
    body_true_answer.textContent = select_true_answer.options[select_true_answer.selectedIndex].textContent;
}

/**
 * Update the number of check questions
 */
function countCheckboxBox() {
    
    var allCheckbox = document.querySelectorAll(".questionCheckbox");
    var numberOfCheckCheckboxEl = document.querySelector("#numberOfCheckCheckbox");
    var numberOfCheckCheckbox = 0;
    for (var i = 0; i<allCheckbox.length; i++) {
        if (allCheckbox[i].checked) {
            numberOfCheckCheckbox ++;
        }
    }

    numberOfCheckCheckboxEl.textContent=numberOfCheckCheckbox + " / " + allCheckbox.length + " spørsmål er avhuket";
}

/**
 * Ask the user for confirmation to delete question
 * @returns true if the user confirm the deletion of the question
 */
function confirmDeletionOfQuestion() {
    return response = confirm("OBS! Husk å lagre endringer før du sletter et spørsmål!");
}

window.onload = function() {
    window.addEventListener('load', checkCheckbox, false);
}



function dontToggle(){
    checkboxes = document.getElementsByClassName('questionCheckbox')
    for (const checkbox of checkboxes){
        checkbox.addEventListener('click', function(event) {
            event.stopPropagation();
        });
        toggleCardColor(checkbox);
    }
}