/* For "Vis for dette året" button */
function setYear() {
  var currentYear = new Date().getFullYear();
  var start = currentYear + "-01-01";
  var end = currentYear + "-12-31";
  document.getElementById("start").value = start;
  document.getElementById("end").value = end;
  document.getElementById("show_stats").submit();
}

function pageLoder(tabId) {
  page1 = document.getElementById("page1id");
  page2 = document.getElementById("page2id");
  page3 = document.getElementById("page3id");

  activePage = document.getElementById(tabId);

  page1.value = 0;
  page2.value = 0;
  page3.value = 0;

  activePage.value = 1;
}

function loadGrafs(answers_whit_questions_description, f1Scor, numberOfQuestion, years, 
      numberOfQuestionsPerYear, accuracyPerSeason, 
      f1ScoreByYear, totalAccuracy, colors, 
      numberOfQuestionEachInteval, dates, all_categories) {
    showF1Score(answers_whit_questions_description, f1Scor, colors);
    showDistributionByAnswer(answers_whit_questions_description, numberOfQuestion, colors);
    showNumberOfQuestionsByYears(years.reverse(), numberOfQuestionsPerYear.reverse());
    showAccuracyByYear(years, accuracyPerSeason);
    showTotalAccuracy(totalAccuracy);
    showF1ScoreByYear(years, all_categories, f1ScoreByYear, colors)
    showTotalNumberOfQuestionsByInterval(numberOfQuestionEachInteval, dates)
}

const actions = [
    {
      name: 'Randomize',
      handler(chart) {
        chart.data.datasets.forEach(dataset => {
          dataset.data = Utils.numbers({count: chart.data.labels.length, min: 0, max: 100});
        });
        chart.update();
      }
    },
    {
      name: 'Add Data',
      handler(chart) {
        const data = chart.data;
        if (data.datasets.length > 0) {
          data.labels.push('data #' + (data.labels.length + 1));
  
          for (let index = 0; index < data.datasets.length; ++index) {
            data.datasets[index].data.push(Utils.rand(0, 100));
          }
  
          chart.update();
        }
      }
    },
    {
      name: 'Remove Data',
      handler(chart) {
        chart.data.labels.splice(-1, 1); // remove the label first
  
        chart.data.datasets.forEach(dataset => {
          dataset.data.pop();
        });
  
        chart.update();
      }
    }
  ];

function showF1Score(answers, f1Scor, colors) {

    var xValues = answers;
    var yValues = f1Scor;

    new Chart("f1Score", {
    type: "horizontalBar",
    data: {
        labels: xValues,
        datasets: [{
        backgroundColor: colors,
        data: yValues
        }]
    },
    options: {
        indexAxis: 'y',
        responsive: true,
        legend: {display: false},
        plugins: {
            legend: {
                position: 'right'
            }
        },
        scales: {
            xAxes: [{ticks: {min: 0, max:100}}],
        },
        title: {
            display: true,
            text: "Treff-prosent (F1-score)"}
    }
    });
}

function showF1ScoreByYear(years, answers, f1ScoreByYear, colors) {

  var xValues = years;

  datasets = []
  for (var i=0; i<f1ScoreByYear.length; i++) {
    datasets.push({
      label: answers[i],
      data: f1ScoreByYear[i],
      borderColor: colors[i],
      fill: false
    })
  }
  new Chart("f1ScoreByYear", {
    type: "line",
    data: {
      labels: xValues,
      datasets: datasets
    },
    options: {
      legend: {display: true},
      responsive: true,
    }
  });
}

function showDistributionByAnswer(answers, numberOfQuestion, colors) {

    var xValues = answers;
    var yValues = numberOfQuestion;

    new Chart("distributionByAnswer", {
    type: "doughnut",
    data: {
        labels: xValues,
        datasets: [{
        backgroundColor: colors,
        data: yValues
        }]
    },
    options: {
        //legend: {display: false},
        responsive: true,
        plugins: {
            legend: {
                position: 'up',
            },
        },
        title: {
            display: true,
            text: "Fordeling per kategori  "}
    }
    });
}

function showNumberOfQuestionsByYears(years, numberOfQuestionEachYear) {

    var xValues = years;
    var yValues = numberOfQuestionEachYear;

    new Chart("numberOfQuestions", {
        type: "line",
        data: {
          labels: xValues,
          datasets: [{
            fill: false,
            lineTension: 0,
            backgroundColor:"rgba(0,0,255,1.0)",
            borderColor: "rgba(0,0,255,0.1)",
            data: yValues
          }]
        },
        options: {
            indexAxis: 'y',
            legend: {display: false},
            plugins: {
                legend: {
                position: 'right'
                }
            },
            title: {
                display: true,
                text: "Antall nye spørsmål kvart år "}
        }
      });
}

function showTotalNumberOfQuestionsByInterval(numberOfQuestionEachInteval, dates) {

  var xValues = dates;
  var yValues = numberOfQuestionEachInteval;

  new Chart("showTotalNumberOfQuestionsByInterval", {
      type: "line",
      data: {
        labels: xValues,
        datasets: [{
          fill: false,
          lineTension: 0,
          backgroundColor:"rgba(0,0,255,1.0)",
          borderColor: "rgba(0,0,255,0.1)",
          data: yValues
        }]
      },
      options: {
          indexAxis: 'y',
          legend: {display: false},
          plugins: {
              legend: {
              position: 'right'
              }
          },
          title: {
              display: true,
              text: "totalt antall spørsmål etter tid"}
      }
    });
}

function showAccuracyByYear(years, accuracyPerSeason) {

    var xValues = years;
    var yValues = accuracyPerSeason;

    new Chart("accuracy", {
        type: "line",
        data: {
          labels: xValues,
          datasets: [{
            fill: false,
            lineTension: 0,
            backgroundColor:"rgba(0,0,255,1.0)",
            borderColor: "rgba(0,0,255,0.1)",
            data: yValues
          }]
        },
        options: {
            indexAxis: 'y',
            legend: {display: false},
            plugins: {
                legend: {
                position: 'right'
                }
            },
            title: {
                display: true,
                text: "Treffsikerheten per år i prosent "}
        }
      });
}

function showTotalAccuracy(totalAccuracy) {

    var xValues = ["Totall treffsikkerhet"];
    var yValues = [totalAccuracy];

    new Chart("totalAccuracy", {
    type: "horizontalBar",
    data: {
        labels: xValues,
        datasets: [{
            axis: 'y',
            backgroundColor: "green",
            data: yValues
        }]
    },
    options: {
        indexAxis: 'y',
        responsive: true,
        legend: {display: false},
        plugins: {
            legend: {
                position: 'right'
            }
        },
        scales: {
            xAxes: [{ticks: {min: 0, max:100}}],
          },
        title: {
            display: true,
            text: "total treffsikkerhet"}
    }
    });
}




